// CSE 154 Ajax Section Problem: Pet-It (solution)
// original page idea and code by Stefanie Hatcher

var counter = 0;   // currently selected breed
var breeds = [];   // array of all breed names as strings

window.onload = function() {
	document.getElementById("dogs").onchange = getBreeds;
	document.getElementById("cats").onchange = getBreeds;
	document.getElementById("nextblob").onclick = nextClick;
};

// Part 1: get the list of all breeds of cats/dogs using Ajax
function getBreeds() {
	var ajax = new XMLHttpRequest();
	ajax.onload = listBreeds;
	ajax.open("GET", "https://webster.cs.washington.edu/cse154/sections/ajax/petit/" + this.value + ".xml", true);
	ajax.send();
}

// Part 1: displays a list of breeds of animal
function listBreeds() {
	document.getElementById("breeds").innerHTML = "";
	breeds = [];
	var breedTags = this.responseXML.getElementsByTagName("breed");
	for (var i = 0; i < breedTags.length; i++) {
		var breed = breedTags[i].firstChild.nodeValue;
		var li = document.createElement("li");
		li.innerHTML = breed;
		li.id = convert(breed);
		document.getElementById("breeds").appendChild(li);
		breeds.push(breed);
	}

	// show the first of the breeds
	counter = 0;
	displayBreedInfo(0);
}


// Part 2: displays the information about a particular cat/dog breed
function displayBreedInfo(index) {
	// get/display info about the breed
	var breed = breeds[index];
	var breedUnderscore = convert(breed);

	var ajax = new XMLHttpRequest();
	ajax.onload = showBreedInfo;
	ajax.open("GET", "https://webster.cs.washington.edu/cse154/sections/ajax/petit/breeds/" + breedUnderscore + ".html", true);
	ajax.send();

	// show the image for the breed
	document.getElementById("pet").src = "https://webster.cs.washington.edu/cse154/sections/ajax/petit/breeds/" + breedUnderscore + ".jpg";

	// Part 3: set up next breed image
	var nextIndex = (index + 1) % breeds.length;
	document.getElementById("next").src = "https://webster.cs.washington.edu/cse154/sections/ajax/petit/breeds/" + convert(breeds[nextIndex]) + ".jpg";

	// Part 3: highlight the name of the currently shown breed
	var allBreeds = document.querySelectorAll("#breeds li");
	for (var i = 0; i < allBreeds.length; i++) {
		allBreeds[i].classList.remove("selected");
	}
	document.getElementById(breedUnderscore).classList.add("selected");
}

function showBreedInfo() {
	document.getElementById("show").innerHTML = this.responseText;
}

// Parts 2/3: converts breed such as "Chow Chow" to string such as "chow_chow"
function convert(breed) {
	return breed.toLowerCase().replace(/ /g, "_");
}

// Part 3: called when "Next" area is clicked.  Moves to next breed
function nextClick() {
	counter = (counter + 1) % breeds.length;
	displayBreedInfo(counter);
}
